package ch.zhaw.gartenverwaltung.notifier;

import ch.zhaw.gartenverwaltung.models.GardenSchedule;
import ch.zhaw.gartenverwaltung.types.Task;

import java.io.IOException;
import java.time.LocalDate;
import java.util.function.Consumer;

public class Notifier implements Runnable{
    private final GardenSchedule gardenSchedule;

    public Notifier(GardenSchedule gardenSchedule) {
        this.gardenSchedule = gardenSchedule;
    }

    private void sendNotification(Task task){
        // TODO implement
    }

    @Override
    public void run() {
        try {
            gardenSchedule.getTaskList().forEach(new Consumer<Task>() {
                @Override
                public void accept(Task task) {
                    if(task.getNextNotification() != null && task.getNextNotification().isBefore(LocalDate.now().minusDays(1))){
                        sendNotification(task);
                        task.setNextNotification(task.getNextExecution());
                    }
                }
            });
        } catch (IOException e) {
            // TODO Logger
            e.printStackTrace();
        }
    }
}
